import tensorflow as tf
import numpy as np
import input_data
from PIL import Image
from utils import tile_raster_images
import pdb


def sample_prob(probs):
    return tf.nn.relu(
        tf.sign(
            probs - tf.random_uniform(tf.shape(probs))))

alpha = .5
batchsize = 100
n_hidden=200

mnist = input_data.read_data_sets("MNIST_data/", one_hot=True)
trX, trY, teX, teY = mnist.train.images, mnist.train.labels, mnist.test.images,\
    mnist.test.labels

X = tf.placeholder("float", [None, 784])
Y = tf.placeholder("float", [None, 10])


rbm_w = tf.placeholder("float", [784, n_hidden])
rbm_vb = tf.placeholder("float", [784])
rbm_hb = tf.placeholder("float", [n_hidden])
h0 = sample_prob(tf.nn.sigmoid(tf.matmul(X, rbm_w) + rbm_hb))
h2 = tf.nn.sigmoid(tf.matmul(X, rbm_w) + rbm_hb)
v1 = sample_prob(tf.nn.sigmoid(
    tf.matmul(h0, tf.transpose(rbm_w)) + rbm_vb))
for nbr_Gibbs in range(0):
	h0 = sample_prob(tf.nn.sigmoid(tf.matmul(v1, rbm_w) + rbm_hb))
	v1 = sample_prob(tf.nn.sigmoid(tf.matmul(h0, tf.transpose(rbm_w)) + rbm_vb))
h1 = tf.nn.sigmoid(tf.matmul(v1, rbm_w) + rbm_hb)
w_positive_grad = tf.matmul(tf.transpose(X), h2)
w_negative_grad = tf.matmul(tf.transpose(v1), h1)
update_w = rbm_w + alpha * \
    (w_positive_grad - w_negative_grad) / tf.to_float(tf.shape(X)[0])
update_vb = rbm_vb + alpha * tf.reduce_mean(X - v1, 0)
update_hb = rbm_hb + alpha * tf.reduce_mean(h0 - h1, 0)


h_sample = sample_prob(tf.nn.sigmoid(tf.matmul(X, rbm_w) + rbm_hb))
v_sample = sample_prob(tf.nn.sigmoid(
    tf.matmul(h_sample, tf.transpose(rbm_w)) + rbm_vb))
err = X - v_sample
err_sum = tf.reduce_mean(err * err)

sess = tf.Session()




n_w = np.zeros([784,n_hidden], np.float32)
n_vb = np.zeros([784], np.float32)
n_hb = np.zeros([n_hidden], np.float32)
#o_w = np.zeros([784, n_hidden], np.float32)
o_w = np.random.normal(loc=0, scale=0.1, size=[784, n_hidden])*0
o_vb = np.zeros([784], np.float32)
o_hb = np.zeros([n_hidden], np.float32)
init = tf.initialize_all_variables()
sess.run(init)
nbr_epocs=10
print len(trX)
print sess.run(
    err_sum, feed_dict={X: trX, rbm_w: o_w, rbm_vb: o_vb, rbm_hb: o_hb})
for iter in range(nbr_epocs):
	IndexShuffle=np.random.permutation(len(trX))
	for start, end in zip(
	        range(0, len(trX), batchsize), range(batchsize, len(trX), batchsize)):
	    batch = trX[np.ix_(IndexShuffle[start:end])]
	    n_w = sess.run(update_w, feed_dict={
	                   X: batch, rbm_w: o_w, rbm_vb: o_vb, rbm_hb: o_hb})
	    n_vb = sess.run(update_vb, feed_dict={
	                    X: batch, rbm_w: o_w, rbm_vb: o_vb, rbm_hb: o_hb})
	    n_hb = sess.run(update_hb, feed_dict={
	                    X: batch, rbm_w: o_w, rbm_vb: o_vb, rbm_hb: o_hb})
	    o_w = n_w
	    o_vb = n_vb
	    o_hb = n_hb
	    o_v1 = sess.run(v1, feed_dict={
	                    X: batch, rbm_w: o_w, rbm_vb: o_vb, rbm_hb: o_hb})

	    if start % 10000 == 0:
	        print sess.run(
	            err_sum, feed_dict={X: trX, rbm_w: n_w, rbm_vb: n_vb, rbm_hb: n_hb})
	        image = Image.fromarray(
	            tile_raster_images(
	                X=n_w.T,
	                img_shape=(28, 28),
	                tile_shape=(25, 20),
	                tile_spacing=(1, 1)
	            )
	        )
	        imageGibbs = Image.fromarray(
				tile_raster_images(
					X=o_v1,
					img_shape=(28, 28),
	                tile_shape=(25, 20),
	                tile_spacing=(1, 1)
	            )
	        )
	imageGibbs.save("Gibbsrbm.png")
	image.save("Wrbm.png")
pdb.set_trace()
h2 = tf.nn.sigmoid(tf.matmul(X, rbm_w) + rbm_hb)

import pickle

# obj0, obj1, obj2 are created here...

# Saving the objects:
with open('objs.pickle', 'w') as f: pickle.dump([n_w, n_hb], f)

